int piezo = 9;  
int ledPin = 13;
int fadePin = 11;

boolean state = false;
boolean dirLed = false;
int val=0;
int sensor=0;
float counter = 0;
int fadeLevel = 0;
int inc = 10;

long timer1 = 0;
long timer2 = 0;

void setup()                 
{
  pinMode(piezo, OUTPUT); 
  pinMode(ledPin, OUTPUT); 
  Serial.begin(9600);
  timer1 = millis();  
  timer2 = millis();  
}


void loop(){
  val=analogRead(sensor);
  if(val>20 && val < 800){
    inc = map(val, 20, 800, 10, 100);
    val = map(val, 20, 800, 2000,100);
    digitalWrite(piezo,HIGH);
//    delayMicroseconds(val*(1+counter));
    delayMicroseconds(val);
    digitalWrite(piezo,LOW);
//    delayMicroseconds(val/(1+counter));
    delayMicroseconds(val);
  } else if (val >= 800)
  {
    inc = 255;
    val = map(val, 20, 1023, 2000, 900);
    digitalWrite(piezo,HIGH);
    delayMicroseconds(val*(1+counter));
    digitalWrite(piezo,LOW);
    delayMicroseconds(val/(1+counter));
    counter+=0.01;
  } else if (val < 20)
  {
    inc = 10;
  }
  if(counter>=0.1){
    counter=0;
  }
  if(millis() - timer1 > 500)
  {
    Serial.println(val,DEC);
    timer1 = millis();
    digitalWrite(ledPin, state = !state);
  }
  if(millis() - timer2 > 100)
  {
    if (!dirLed) fadeLevel += inc;
    else fadeLevel -= inc;
    if (fadeLevel >= 255)
    { 
      fadeLevel = 255;
      dirLed = !dirLed;
    }
    if (fadeLevel <= 0)
    { 
      fadeLevel = 0;
      dirLed = !dirLed;
    }
    analogWrite(fadePin, fadeLevel);
    timer2 = millis();
  }
}


